# Vportage.py
# Author: Ryan Mulligan
#
# The purpose of this is to move vpython programs into szysgy
#
#
# At all points where I have dsg I mean distributed scene graph
#
################################################################################
################################################################################

#import szyszgy

from PySZG import *
from vportage_utils import *
import time
from threading import Thread


#in vportage we make a framework, so we display stuff.
dsg_framework = arDistSceneGraphFramework()
dsg_framework.setAutoBufferSwap(1)

#required by the framework.
if dsg_framework.init(sys.argv) != 1:
	sys.exit()
					
dsg_database = dsg_framework.getDatabase()
add_lights_to(dsg_database)

root_database_node = dsg_database.getRoot()

navigation_node = root_database_node.new("transform")

world_node = navigation_node.new("transform")
world_node.setTransform(translation_matrix(0,5,-50))

nav = navigator()
nav.node = navigation_node

# Starts all the services, windows, etc. 
if dsg_framework.start() != 1:
	sys.exit()
	
#This is a thread that does setViewer
class DSGFrameWorkUpdate(Thread):
	def __init__ (self, dsg):
		Thread.__init__(self)
		self.dsg_framework = dsg;
	def run(self):
		while True:
			self.dsg_framework.setViewer()
			nav.update(dsg_framework, time.clock())
			
	
updater_thread =DSGFrameWorkUpdate(dsg_framework)
updater_thread.start()
			
###Primatives
###The code for these is mostly in utils.
class frame(vportage_utils.frame):
	def __init__(self, frame = None, pos = (0,0,0)):
		parent_frame = frame
		position_offset_from_parent = pos
		
				
		if parent_frame:
			vportage_utils.frame.__init__(self,frame = parent_frame, pos = pos)
		else:
			vportage_utils.frame.__init__(self,transform_node = world_node, pos = pos)
			
		self.pos = position_offset_from_parent
	
#This is a hook frame on the world_node.
root_frame = frame()


class sphere(vportage_utils.sphere):
	def __init__(self,frame = root_frame, pos = (0,0,0), color = (0,0,0), radius = 1):
		vportage_utils.sphere.__init__(self,frame = frame, pos = pos, color = color, radius = radius)
			
class ellipsoid(vportage_utils.ellipsoid):
	def __init__(self,frame = root_frame, pos=(0,0,0), color=(0,0,0), size = (1,1,1), length = 1, width = 1, depth = 1):
		vportage_utils.ellipsoid.__init__(self,frame = frame, pos = pos, size = size, length = length, width = width, depth = depth, color = color)		
		
class box(vportage_utils.box):
	def __init__(self,frame = root_frame, pos = (0,0,0), color = (0,0,0), size = (1,1,1), length = 1, height = 1, width = 1):
		vportage_utils.box.__init__(self,frame = frame, pos = pos, color = color, size = size, length = length, height = height, width = width)		
